{

  open Ant_parser

}

rule token = parse
  | [' ' '\t'] +
      { token lexbuf }

  | "Sense" { SENSE }
  | "Mark" { MARK }
  | "Unmark" { UNMARK }
  | "PickUp" { PICKUP }
  | "Drop" { DROP }
  | "Turn" { TURN }
  | "Move" { MOVE }
  | "Flip" { FLIP }

  | "Here" { HERE }
  | "Ahead" { AHEAD }
  | "LeftAhead" { LEFTAHEAD }
  | "RightAhead" { RIGHTAHEAD }

  | "Friend" { FRIEND }
  | "Foe" { FOE }
  | "FriendWithFood" { FRIENDWITHFOOD }
  | "FoeWithFood" { FOEWITHFOOD }
  | "Food" { FOOD }
  | "Rock" { ROCK }
  | "Marker" { MARKER }
  | "FoeMarker" { FOEMARKER }
  | "Home" { HOME }
  | "FoeHome" { FOEHOME }

  | "Left" { LEFT }
  | "Right" { RIGHT }

  | ';' [^ '\n']* '\n' 
      { EOL }
  | '\n' 
      { EOL }

  | ['0'-'9']+
      { INT(int_of_string (Lexing.lexeme lexbuf)) }

  | eof 
      { EOF }
