(*i $Id: types.mli,v 1.1 2004/06/06 17:01:13 filliatr Exp $ i*)

type pos = int * int

type dir = int (* 0..5 *)

type color = Red | Black

type ant = {
  id : int; 
  (* A unique integer that determines the order in which the ant takes its
     turn to move or sense during each round of gameplay. *)

  mutable color : color;

  mutable state : int ;
  (* An integer between 0 and 9999 representing the current
     state of its brain. (All the ants of each species run exactly the
     same program, so the entire neural state of an ant of the species can
     be characterized by just one number. *)

  mutable resting : int ;
  (* An integer that keeps track of how long the ant has to
 rest after its last move before any other action. (Ants move much
 more slowly than they can turn and sense their surroundings. This
 is modeled by making an ant rest for 14 rounds after each time it
 executes a Move instruction. *)

  mutable position : pos ; 

  mutable direction : dir ;

  mutable has_food : bool ;
  (* A boolean indicating whether the ant is currently
     carrying a food particle. (An ant can hold only a single unit of
     food at a time. *)

  mutable is_alive : bool ;
}

type cell = {
  mutable rocky : bool ;
  mutable cell_ant : int option ; (* the id of the ant there if any *)
  mutable ant_hill : color option ;
  mutable food : int ;
  mutable red_markers : bool array;
  mutable black_markers : bool array;
}

type brain = Instr.instruction array
