
open Ast

let rec pre_eval = function
    Not e -> 
      (match pre_eval e with
	  True -> False
	| False -> True
	| e -> Not e)
  | And (e1,e2) ->
      (match pre_eval e1 with
	   False -> False
	 | True -> pre_eval e2
	 | e10 -> (match pre_eval e2 with
		       False -> False
		     | True -> e10
		     | e20 -> And(e10,e20)))
  | Or (e1,e2) ->
      (match pre_eval e1 with
	   False -> pre_eval e2 
	 | True -> True
	 | e10 -> (match pre_eval e2 with
		       False -> e10
		     | True -> True
		     | e20 -> Or(e10,e20)))
  | e -> e

let rec push = function
    Not e -> push_not e
  | And(e1,e2) -> And(push e1,push e2)
  | Or(e1,e2) -> Or(push e1,push e2)
  | e -> e
and push_not = function
    Not e -> push e
  | And(e1,e2) -> Or(push_not e1,push_not e2)
  | Or(e1,e2) -> And(push_not e1,push_not e2)
  | True -> False
  | False -> True
  | e -> e

let simplify e = pre_eval (push e)
