
open Flatten

type address=
    At of int
  | Fu2 of string
  | Bottom

let rec find_cont n = function
    [] -> Bottom
  | finstr::cont -> 
      match finstr with
	  FGoto l -> Fu2 l
	| FLbl _ -> find_cont n cont
	| _ -> At n

module Stringset=Set.Make(struct type t=string let compare=compare end)  

let resolve_lbl prg =
  let labels = Hashtbl.create 251 in
  let state_cnt = ref 0 in
  let rec register = function
      [] -> []
    | flat::cont ->
	match flat with
	    FLbl s -> 
	      let ad=find_cont !state_cnt cont in
		Hashtbl.add labels s ad;
		(match ad with 
		     Fu2 _ -> s :: register cont
		   | _ -> register cont)
	  | FGoto _ -> register cont
	  |  _ -> incr state_cnt; register cont in
  let rec visit ctx l=
    match Hashtbl.find labels l with
	(At _ | Bottom) as ad -> 
	  Stringset.iter (fun s -> Hashtbl.replace labels s ad) ctx
      | Fu2 l0 -> 
	  if Stringset.mem l0 ctx then
	    Stringset.iter (fun s -> Hashtbl.replace labels s Bottom)
	      (Stringset.add l ctx)
	  else
	    visit (Stringset.add l ctx) l0 in
  let unresolved=register prg in
    List.iter (fun s->visit Stringset.empty s) unresolved;
    let find_ad s = 
      match Hashtbl.find labels s with
	  Bottom -> !state_cnt (* illegal loops are bottomless pits *)
	| At n -> n
	|  _ -> assert false in
    let find_next n prg=
      match find_cont n prg with
	  Bottom -> !state_cnt
	| At _ ->   n
	| Fu2 l ->  find_ad l in
      (find_ad,find_next)




