type left_or_right = Left | Right
type marker = int

type sense_dir = 
  | Here           
  | Ahead          
  | LeftAhead      
  | RightAhead     

type condition =
  | Friend        
  | Foe           
  | FriendWithFood 
  | FoeWithFood    
  | Food           
  | Rock           
  | Marker of int
  | FoeMarker       
  | Home            
  | FoeHome         

type instruction =
  | Sense of sense_dir * Label.t * Label.t * condition  
  | Mark of marker * Label.t
  | Unmark of marker * Label.t
  | PickUp of Label.t * Label.t
  | Drop of Label.t
  | Turn of left_or_right * Label.t
  | Move of Label.t * Label.t
  | Flip of int * Label.t * Label.t

type instr = Label.t * instruction
