open Format

let parse_only = ref false
let symbolic = ref false

let ifile = ref "";;
let ofile = ref "";;

let set_file f s = f :=s 

let options = 
  [("-parse-only",Arg.Set parse_only , " analyse syntaxique uniquement");
   ("-symbolic",Arg.Set symbolic , " dump le code symbolic");
   ("-o", Arg.String (set_file ofile) , 
    "<file>  Pour indiquer le nom du fichier de sortie")];;

let usage = "usage: fourmilier [option] file.frm";;



let _ = 
  Arg.parse options (set_file ifile) usage;
  if !ifile="" then (eprintf "Aucun fichier a compiler\n@?"; exit 1); 
  if not (Filename.check_suffix !ifile ".frm") then 
    (eprintf "Le fichier d'entree doit avoir l'extension .frm\n@?";
     Arg.usage options usage;exit 1); 
  if !ofile="" then ofile := (Filename.chop_suffix !ifile ".frm") ^ ".ant";
  
  let f = open_in !ifile in
  let buf = Lexing.from_channel f in

    try
      let p = Parser.prog Lexer.token buf in
	close_in f;
	if !parse_only then exit 0;
	Compile.compile_prg p !ofile !symbolic;
    with
	Lexer.Error s -> 
	  Syntaxerr.position !ifile (Lexing.lexeme_start buf);
	  eprintf "Erreur dans l'analyse lexicale: %s\n@?" s
      | Parsing.Parse_error -> 
	  Syntaxerr.position !ifile (Lexing.lexeme_start buf);
	  eprintf "Erreur dans l'analyse syntaxique\n@?"
;;	  







